#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
#define CRP(t, x) const t &x
#define OPL(t, x) bool operator<(CRP(t, x)) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
typedef long long ll, i64;
const int N = 2e5 + 50;
int a[N];
inline ll Log2(ll x)
{
    int r = 0;
    while ((1ll << r) <= x) r++;
    return r;
}
ll Mask(ll x) { return (1ll << Log2(x)) - 1; }
int main()
{
    //for (int i = 0; i < 100; i++) printf("%d:%d\n", i, Log2(i));
    int T, n;
    scanf("%d", &T);
    while (T--)
    {
        scanf("%d", &n);
        printf("%d\n", n == Mask(n));
        for (int i = 2; i <= n; i++)
        {
            int r = i ^ ((1 << Log2(i)) - 1);
            r = r & -r;
            if (r == 0) r = i == n ? 1 : i + 1;
            a[i] = r;
        }
        for (int i = 2; i <= n; i++) printf("%d%c", a[i], " \n"[i == n]);
    }
    return 0;
}